widget_OhMyBash/assignments/urls.py
from django.urls import path
from .views import Assignments, AssignmentDetailView, AssignmentAddView, AssignmentEditView

urlpatterns = [
    path('', Assignments, name="assignments"),
    path('<int:pk>/details/', AssignmentDetailView.as_view(), name='assignment-details'),
    path('add/', AssignmentAddView.as_view(), name='assignment-add'),
    path('<int:pk>/edit/', AssignmentEditView.as_view(), name='assignment-edit'),
]

app_name = 'assignments'

widget_OhMyBash/forum/urls.py
from django.urls import path

from .views import (forum, ForumPostDetailView,
                    ForumPostCreateView, ForumPostUpdateView)

urlpatterns = [
    path('', forum, name='forum'),
    path('forumposts/<int:pk>/details/',
         ForumPostDetailView.as_view(),
         name='forumpost-details'),
    path('forumposts/add/',
         ForumPostCreateView.as_view(),
         name='forumpost-create'),
    path('forumposts/<int:pk>/edit/',
         ForumPostUpdateView.as_view(),
         name='forumpost-update'),
]

app_name = "forum"

widget_OhMyBash/widget_OhMyBash/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('', include('dashboard.urls', namespace="dashboard")),
    path('forum/', include('forum.urls', namespace="forum")),
    path('announcements/', include('announcements.urls', namespace="announcements")),
    path('calendar/', include('widget_calendar.urls', namespace="calendar")),
    path('assignments/', include('assignments.urls', namespace="assignments")),
    path('admin/', admin.site.urls),
]

widget_OhMyBash/assignments/models.py
from django.db import models
from django.urls import reverse


class Course(models.Model):
    code = models.CharField(max_length=10)
    title = models.CharField(max_length=100)
    section = models.CharField(max_length=3)

    def __str__(self):
        return '''{}, {}, {}'''.format(
            self.code,
            self.title,
            self.section,
            )


class Assignment(models.Model):
    name = models.CharField(max_length=50)
    description = models.TextField()
    course = models.ForeignKey(Course, on_delete=models.CASCADE)
    perfect_score = models.IntegerField()

    def __str__(self):
        return'''{}, {}, {}, {}'''.format(
            self.name,
            self.description,
            self.course,
            self.perfect_score,
            )

    def passing_score(self):
        return round(self.perfect_score * 0.6)

    def get_absolute_url(self):
        return reverse('assignments:assignment-details', kwargs={'pk': self.pk})

widget_OhMyBash/assignments/views.py
from django.shortcuts import render
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView
from django.views.generic.edit import UpdateView

from .models import Assignment


def Assignments(request):
    assignments = Assignment.objects.all()
    dict_assignments = {
        'assignments': assignments,
    }
    return render(request, 'assignments/assignments.html', dict_assignments)


class AssignmentDetailView(DetailView):
    model = Assignment
    template_name = 'assignments/assignment-details.html'


class AssignmentAddView(CreateView):
    model = Assignment
    fields = '__all__'
    template_name = 'assignments/assignment-add.html'


class AssignmentEditView(UpdateView):
    model = Assignment
    fields = '__all__'
    template_name = 'assignments/assignment-edit.html'

widget_OhMyBash/assignments/templates/assignments/assignment-add.html
{% extends 'base.html' %}
{% block title %} Add Assignment {% endblock %}
{% block heading %} <h1> Add a new assignment: </h1> {% endblock %}
{% block content %}
    <form method="POST">
        {% csrf_token %}
        {{ form.as_p }}
        <p class="centerB">
            <input class="submitB" type="SUBMIT" value="Save New Assignment">
        </p>
        
    </form>
{% endblock %}

widget_OhMyBash/assignments/templates/assignments/assignment-details.html
{% extends 'base.html' %}
{% block title %} {{ assignment.name }} {% endblock %}
{% block heading %} <h1> {{ assignment.name }} </h1> {% endblock %}
{% block content %}
        <p>
            {{ assignment.course.code }} {{ assignment.course.title }} - {{ assignment.course.section }}<br>
            Description: {{ assignment.description }}<br>
            Perfert Score: {{ assignment.perfect_score }}<br>
            Passing Score: {{ assignment.passing_score }}
        </p>
        <p class="centerB">
            <a href="{% url 'assignments:assignment-edit' assignment.id %}">
                <button class="btn">Edit Assignment</button>
            </a>
        </p>
{% endblock %}

widget_OhMyBash/assignments/templates/assignments/assignment-edit.html
{% extends 'base.html' %}
{% block title %} Edit Assignment {% endblock %}
{% block heading %} <h1> Edit Assignment: </h1>{% endblock %}
{% block content %}
    <form method="POST">
        {% csrf_token %}
        {{ form.as_p }}
        <p class="centerB">
            <input class="submitB" type="SUBMIT" value="Save Changes to Assignment">
        </p>
    </form>
{% endblock %}

widget_OhMyBash/assignments/templates/assignments/assignments.html
{% extends 'base.html' %}
{% load static %}

{% block title %} Widget's Assignments {% endblock %}
{% block heading %} <h1> Welcome to Widget's Assignments! </h1>{% endblock %} 

{% block content %}
    <p class="list">
            {% for assignment in assignments %}
            <a href="{{ assignment.get_absolute_url }}">
                {{assignment.name}} <br>
            </a>
            {% endfor %}
    </div>
    <p class="centerB">
        <button class="btn add">
            <a href="{% url 'assignments:assignment-add' %}">New Assignment</a>
        </button>
    </p>
{% endblock %}
{% block footing %}
<p class="links">
    <a href="/dashboard/" class="link">Dashboard</a><br>
    <a href="/announcements/" class="link"> Announcements</a><br>
    <a href="/forum/" class="link">Forum</a><br>
    <a href="/calendar/" class="link">Calendar</a>
</p>
{% endblock %}